<template lang="pug">
q-item
  q-dialog(v-model="editing")
    EditMessage(
      v-if="editing",
      :message="message",
      :cancel="() => (editing = false)",
      :save="handleSaveEdit",
      :zoomSensors="zoomSensors"
    )
  q-dialog(ref="selectSensor")
    q-card
      q-card-section.text-h6 Please select a sensor to send the message to:
        q-select(
          v-if="message.config.type === 'sensor'",
          label="Sensor",
          :options="zoomSensors",
          v-model="sensorToSendTo"
        )
      q-card-actions(align="right")
        q-btn(
          flat,
          label="OK",
          color="primary",
          :disabled="!sensorToSendTo",
          @click="onSensorToSendToSelected",
          v-close-popup,
          :loading="setSensorToSendToLoading"
        )
  q-item-section.col-8
    q-item-label.row.items-center {{ message.name }}
      i.q-ml-sm(v-if="message.config.sensors") ({{ message.config.sensors }})
      q-btn.q-ml-sm(
        v-if="editMessage",
        flat,
        dense,
        round,
        size="0.6rem",
        icon="edit",
        :disabled="sendLoading || deleteLoading",
        @click="editing = true"
      )
      q-btn.q-ml-sm(
        v-if="deleteMessage",
        color="negative",
        @click="handleDeleteMessage",
        flat,
        dense,
        round,
        icon="delete",
        size="0.6rem",
        :disabled="sendLoading",
        :loading="deleteLoading"
      )
    q-item-label(caption) {{ message.content }}
  q-item-section
    q-item-label(caption)
      .row.items-center(v-if="message.sent")
        q-space
        i Sent
        q-btn.q-ml-md(
          v-if="sendMessage && message.config.from === 'manual'",
          label="resend",
          color="primary",
          @click="sendManualMessage",
          :loading="sendLoading",
          :disabled="deleteLoading"
        )
      .row.items-center(v-if="!message.sent")
        q-space
        q-icon.text-h5(v-if="message.config.from === 'end' && !sendTime" name="pause" )
          q-tooltip The section timer is paused.
        CircularCountdown(
          v-if="message.config.from !== 'manual' && sendTime && sendTime > now",
          :startTime="sectionStartTime",
          :endTime="sendTime",
        )
        i(
          v-if="message.config.from !== 'manual' && sendTime && sendTime < now"
        ) Pending Send
        q-btn(
          v-if="sendMessage && message.config.from === 'manual'",
          icon="send",
          color="primary",
          :loading="sendLoading",
          :disabled="deleteLoading",
          @click="sendManualMessage"
        )
</template>
<script>
import CircularCountdown from "./CircularCountdown.vue";
import EditMessage from "./EditMessage";
import { messageSendTime } from "./messageSendTime";

export default {
  props: {
    message: { required: true },
    sectionEndTime: { required: true },
    sectionStartTime: { required: true },
    editMessage: { required: false },
    sendMessage: { required: false },
    zoomSensors: { required: true },
    deleteMessage: { required: false },
  },
  data() {
    return {
      editing: false,
      now: new Date().valueOf(),
      interval: null,
      sendLoading: false,
      togglePauseLoading: false,
      // This is used in the case where `message.config.type` is "sensor",
      // but `message.config.sensors` isn't present. When the user sends the
      // message, we prompt them to select one or more sensors
      sensorToSendTo: undefined,
      setSensorToSendToLoading: false,
      deleteLoading: false,
    };
  },
  computed: {
    sendTime() {
      return messageSendTime(
        this.message,
        this.sectionStartTime,
        this.sectionEndTime
      );
    },
  },
  methods: {
    async handleDeleteMessage() {
      await this.$q
        .dialog({
          title: "Are you sure you want to delete this message?",
          cancel: true,
        })
        .onOk(async () => {
          this.deleteLoading = true;
          await this.deleteMessage();
          this.deleteLoading = false;
        });
    },
    async handleSaveEdit(editedMessage) {
      await this.editMessage(editedMessage);
      this.editing = false;
    },
    async sendManualMessage() {
      if (
        this.message.config.type === "sensor" &&
        !this.message.config.sensors
      ) {
        this.$refs.selectSensor.show();
        return;
      }
      this.sendLoading = true;
      await this.sendMessage();
      this.sendLoading = false;
    },
    async onSensorToSendToSelected() {
      const { config, ...message } = this.message;
      this.setSensorToSendToLoading = true;
      await this.editMessage({
        ...message,
        config: { ...config, sensor: this.sensorToSendTo },
      });
      this.setSensorToSendToLoading = false;
      this.$refs.selectSensor.hide();
      this.sendManualMessage();
    },
  },
  created() {
    this.interval = setInterval(() => {
      this.now = new Date().valueOf();
    }, 1000);
  },
  destroyed() {
    clearInterval(this.interval);
  },
  components: {
    CircularCountdown,
    EditMessage,
  },
};
</script>
